
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Training Colab &#8212; Battery SOH  documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="_static/css/custom.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="section" id="Training-Colab">
<h1><strong>Training Colab</strong><a class="headerlink" href="#Training-Colab" title="Permalink to this headline">¶</a></h1>
<p>This Colab serves for model training. For it to work, a folder called <code class="docutils literal notranslate"><span class="pre">battery_soh</span></code> must be created on google drive and include another folder called <code class="docutils literal notranslate"><span class="pre">Battery_SOH_</span></code> + the date of the most current version (<code class="docutils literal notranslate"><span class="pre">day_month</span></code>). This <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> should contain all of the necessary files (<code class="docutils literal notranslate"><span class="pre">Pytorch_Dataset.py</span></code>, <code class="docutils literal notranslate"><span class="pre">Training.py</span></code>, <code class="docutils literal notranslate"><span class="pre">NN_Classes.py</span></code>, <code class="docutils literal notranslate"><span class="pre">Nasa_Classes.py</span></code> and the dataset files).</p>
<p>An example can be found in the following google drive link (you’ll need to ask for access): <a class="reference external" href="https://drive.google.com/drive/folders/1G5xLrXHlKq3QpOzaFGusB89_erZPYwa6?usp=sharing">https://drive.google.com/drive/folders/1G5xLrXHlKq3QpOzaFGusB89_erZPYwa6?usp=sharing</a></p>
<p>The following cell includes the bare minimum to mount google drive to google colab so that the files can be directly called. The <code class="docutils literal notranslate"><span class="pre">root_path</span></code> may have to be updated to the latest <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> folder.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drivee</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_24_06_15h&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span> <span class="o">+</span> <span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Mounted at /content/gdrive
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cpu&#39;)
</pre></div></div>
</div>
<p>The cell should output something like:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Mounted at /content/gdrive
device(type=&#39;cuda&#39;, index=0)
</pre></div>
</div>
<p>If the second line says <code class="docutils literal notranslate"><span class="pre">device(type='cpu')</span></code> then you should change your environment options above for GPU for faster results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span>!pip install PyAstronomy
from Severson_Classes_tests import *
from LSTM import *
from RNN import *
from Training import *
from Load_Save import *
from torch.utils.data import DataLoader
from datetime import datetime
import re
from Coin_Classes import *
from Testing import *
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Collecting PyAstronomy
  Downloading https://files.pythonhosted.org/packages/1f/d7/251cbad869abf5834b5bbc1012f76831dfbbf34d60677598dd542ef003ce/PyAstronomy-0.16.0.tar.gz (711kB)
     |████████████████████████████████| 716kB 17.4MB/s
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
Building wheels for collected packages: PyAstronomy
  Building wheel for PyAstronomy (setup.py) ... done
  Created wheel for PyAstronomy: filename=PyAstronomy-0.16.0-cp37-none-any.whl size=504498 sha256=2ee1eec86c88745c5a9391322f0499e011f8315fd0320ed37033aa3e8f03ff4c
  Stored in directory: /root/.cache/pip/wheels/93/af/aa/931d34dfc98c7f7fb4514fb9da32cac3584895cc03e873bdd1
Successfully built PyAstronomy
Installing collected packages: PyAstronomy
Successfully installed PyAstronomy-0.16.0
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">DELTA</span> <span class="o">=</span> <span class="mi">10</span>
<span class="n">fixed_len</span> <span class="o">=</span> <span class="mi">150</span>
<span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">time_step</span> <span class="o">=</span> <span class="mi">30</span>
<span class="n">LSTM_version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="n">norm_type</span> <span class="o">=</span> <span class="s1">&#39;zscore&#39;</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># os.chdir(&#39;.//Datasets/NASA/B. Saha and K Goebel/Separate_pickles&#39;)</span>
<span class="c1"># dataset_name = &#39;Nasa&#39;</span>

<span class="c1"># os.chdir(&#39;.//Datasets/Severson et al./Cleaned_v2/2. 2017-06-30&#39;)</span>
<span class="c1"># dataset_name = &#39;Sev&#39;</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/Tarascon/Coins/Clean_Batteries&#39;</span><span class="p">)</span>
<span class="n">dataset_name</span> <span class="o">=</span> <span class="s1">&#39;Coin&#39;</span>

<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>          <span class="c1"># List with the valid files</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span> <span class="c1"># Only take into acount</span>
                                                <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>


<span class="k">if</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;Nasa&#39;</span><span class="p">:</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">]</span>

    <span class="c1"># The big one</span>
    <span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0018.txt&#39;</span><span class="p">,</span>  <span class="c1"># 24ºC</span>
            <span class="c1">#  &#39;B0025.txt&#39;, &#39;B0026.txt&#39;, &#39;B0027.txt&#39;,  # 24ºC</span>
            <span class="s1">&#39;B0029.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0031.txt&#39;</span><span class="p">,</span>  <span class="c1"># 43ºC</span>
            <span class="s1">&#39;B0036.txt&#39;</span><span class="p">,</span>  <span class="c1"># 24ºC</span>
            <span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span>  <span class="c1"># 44ºC et 24ºC</span>
            <span class="s1">&#39;B0042.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0043.txt&#39;</span><span class="p">,</span>  <span class="c1"># 44ºC et 4ºC</span>
            <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0046.txt&#39;</span><span class="p">,</span>  <span class="c1"># 4ºC</span>
            <span class="s1">&#39;B0053.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0055.txt&#39;</span><span class="p">]</span>  <span class="c1"># 4ºC</span>

<span class="k">elif</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;Coin&#39;</span><span class="p">:</span>
    <span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">8</span><span class="p">)]</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="n">train</span>

<span class="k">elif</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;Sev&#39;</span><span class="p">:</span>

    <span class="n">train_len</span> <span class="o">=</span> <span class="mi">36</span>
    <span class="n">valid_len</span> <span class="o">=</span> <span class="mi">12</span>

    <span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">12</span><span class="p">,</span> <span class="mi">48</span><span class="p">)]</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">12</span> <span class="o">-</span> <span class="n">valid_len</span><span class="p">)]</span>

    <span class="c1"># print(train, &#39;\n&#39;, ignore)</span>

    <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># Training files:</span>
<span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># train_dataset = Torch_Dataset_LSTM_test(Train_list, DELTA, LSTM_version,  # Dataset</span>
<span class="c1">#                                    print_bool=True, time_step=time_step,</span>
<span class="c1">#                                    fixed_len=fixed_len, norm_type=norm_type)</span>

<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span><span class="n">Train_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span>  <span class="c1"># Dataset</span>
                                   <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
                                   <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">)</span>

<span class="k">if</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>  <span class="c1"># Loader</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>  <span class="c1"># Loader</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

<span class="k">if</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                  <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span>
                                  <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>


<span class="c1"># Validation files:</span>
<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># valid_dataset = Torch_Dataset_LSTM_test(Valid_list, DELTA, LSTM_version, # Dataset</span>
<span class="c1">#                                    print_bool=True, time_step=time_step,</span>
<span class="c1">#                                    norm=train_dataset.norm,</span>
<span class="c1">#                                    fixed_len=train_dataset.fixed_len)</span>

<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span><span class="n">Valid_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="c1"># Dataset</span>
                                   <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
                                   <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                                   <span class="n">fixed_len</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span><span class="p">)</span>

<span class="k">if</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>  <span class="c1"># Loader</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span>  <span class="c1"># Loader</span>
                              <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0001
B0001
B0002
B0002
B0003
B0003
B0004
B0004
B0005
B0006
B0006
646
B0008
B0009
B0010
B0010
B0011
112
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_7_0.png" src="_images/Battery_SOH_LSTM_7_0.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">HIDDEN_DIM</span> <span class="o">=</span> <span class="mi">50</span>
<span class="n">DROPOUT</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">pool_type</span> <span class="o">=</span> <span class="s1">&#39;bi_mean&#39;</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">DELTA</span><span class="p">,</span> <span class="n">HIDDEN_DIM</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="n">pool_type</span><span class="p">,</span>
               <span class="n">drop_out</span><span class="o">=</span><span class="n">DROPOUT</span><span class="p">,</span> <span class="n">version</span> <span class="o">=</span> <span class="n">LSTM_version</span><span class="p">,</span>
               <span class="n">norm</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
               <span class="n">lin_dropout</span><span class="o">=</span><span class="mf">0.3</span><span class="p">)</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

<span class="c1"># os.chdir(&#39;.//Reports/2021-06-17 11_20_39.769117-Prés_new&#39;)</span>
<span class="c1"># with open(&#39;best_model.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="c1">#     Model = pickle.load(f)</span>

<span class="c1"># Model = Model.to(device)</span>

<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_8_0.png" src="_images/Battery_SOH_LSTM_8_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_8_1.png" src="_images/Battery_SOH_LSTM_8_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#os.chdir(&#39;../../../../&#39;)</span>
<span class="c1"># os.chdir(&#39;../../&#39;)</span>
<span class="c1"># os.chdir(&#39;../&#39;)</span>
<span class="c1"># print(date)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
/content/gdrive/My Drive/battery_soh/Battery_SOH_24_06_15h
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">75</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">1e-5</span>


<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span><span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span>
                               <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                               <span class="n">sim_loader</span><span class="o">=</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                               <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="nb">print</span><span class="p">(</span><span class="n">date</span><span class="p">)</span>

<span class="c1"># # Best model</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>

<span class="n">Load_Save</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">dataset_name</span><span class="o">=</span><span class="n">dataset_name</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
1 . Training loss:  tensor(0.9737)
1 . Validation loss:  tensor(0.8419)
2 . Training loss:  tensor(0.9424)
2 . Validation loss:  tensor(0.8353)
3 . Training loss:  tensor(0.8947)
3 . Validation loss:  tensor(0.8296)
4 . Training loss:  tensor(0.8253)
4 . Validation loss:  tensor(0.8228)
5 . Training loss:  tensor(0.7369)
5 . Validation loss:  tensor(0.8174)
6 . Training loss:  tensor(0.6431)
6 . Validation loss:  tensor(0.8103)
7 . Training loss:  tensor(0.5558)
7 . Validation loss:  tensor(0.8018)
8 . Training loss:  tensor(0.4799)
8 . Validation loss:  tensor(0.7853)
9 . Training loss:  tensor(0.4179)
9 . Validation loss:  tensor(0.7609)
10 . Training loss:  tensor(0.3670)
10 . Validation loss:  tensor(0.7190)
11 . Training loss:  tensor(0.3241)
11 . Validation loss:  tensor(0.6752)
12 . Training loss:  tensor(0.2872)
12 . Validation loss:  tensor(0.6279)
13 . Training loss:  tensor(0.2559)
13 . Validation loss:  tensor(0.5695)
14 . Training loss:  tensor(0.2297)
14 . Validation loss:  tensor(0.5171)
15 . Training loss:  tensor(0.2076)
15 . Validation loss:  tensor(0.4593)
16 . Training loss:  tensor(0.1889)
16 . Validation loss:  tensor(0.4166)
17 . Training loss:  tensor(0.1731)
17 . Validation loss:  tensor(0.3744)
18 . Training loss:  tensor(0.1595)
18 . Validation loss:  tensor(0.3272)
19 . Training loss:  tensor(0.1478)
19 . Validation loss:  tensor(0.2918)
20 . Training loss:  tensor(0.1379)
20 . Validation loss:  tensor(0.2615)
21 . Training loss:  tensor(0.1295)
21 . Validation loss:  tensor(0.2371)
22 . Training loss:  tensor(0.1222)
22 . Validation loss:  tensor(0.2168)
23 . Training loss:  tensor(0.1161)
23 . Validation loss:  tensor(0.1963)
24 . Training loss:  tensor(0.1107)
24 . Validation loss:  tensor(0.1800)
25 . Training loss:  tensor(0.1060)
25 . Validation loss:  tensor(0.1677)
26 . Training loss:  tensor(0.1019)
26 . Validation loss:  tensor(0.1581)
27 . Training loss:  tensor(0.0982)
27 . Validation loss:  tensor(0.1543)
28 . Training loss:  tensor(0.0945)
28 . Validation loss:  tensor(0.1500)
29 . Training loss:  tensor(0.0907)
29 . Validation loss:  tensor(0.1447)
30 . Training loss:  tensor(0.0866)
30 . Validation loss:  tensor(0.1454)
31 . Training loss:  tensor(0.0827)
31 . Validation loss:  tensor(0.1399)
32 . Training loss:  tensor(0.0788)
32 . Validation loss:  tensor(0.1371)
33 . Training loss:  tensor(0.0752)
33 . Validation loss:  tensor(0.1347)
34 . Training loss:  tensor(0.0719)
34 . Validation loss:  tensor(0.1338)
35 . Training loss:  tensor(0.0690)
35 . Validation loss:  tensor(0.1311)
36 . Training loss:  tensor(0.0662)
36 . Validation loss:  tensor(0.1284)
37 . Training loss:  tensor(0.0636)
37 . Validation loss:  tensor(0.1242)
38 . Training loss:  tensor(0.0610)
38 . Validation loss:  tensor(0.1244)
39 . Training loss:  tensor(0.0585)
39 . Validation loss:  tensor(0.1220)
40 . Training loss:  tensor(0.0559)
40 . Validation loss:  tensor(0.1210)
41 . Training loss:  tensor(0.0535)
41 . Validation loss:  tensor(0.1229)
42 . Training loss:  tensor(0.0509)
42 . Validation loss:  tensor(0.1283)
43 . Training loss:  tensor(0.0484)
43 . Validation loss:  tensor(0.1280)
44 . Training loss:  tensor(0.0461)
44 . Validation loss:  tensor(0.1301)
45 . Training loss:  tensor(0.0436)
45 . Validation loss:  tensor(0.1262)
46 . Training loss:  tensor(0.0414)
46 . Validation loss:  tensor(0.1273)
47 . Training loss:  tensor(0.0390)
47 . Validation loss:  tensor(0.1288)
48 . Training loss:  tensor(0.0370)
48 . Validation loss:  tensor(0.1244)
49 . Training loss:  tensor(0.0351)
49 . Validation loss:  tensor(0.1205)
50 . Training loss:  tensor(0.0332)
50 . Validation loss:  tensor(0.1182)
51 . Training loss:  tensor(0.0315)
51 . Validation loss:  tensor(0.1137)
52 . Training loss:  tensor(0.0300)
52 . Validation loss:  tensor(0.1133)
53 . Training loss:  tensor(0.0284)
53 . Validation loss:  tensor(0.1080)
54 . Training loss:  tensor(0.0272)
54 . Validation loss:  tensor(0.1046)
55 . Training loss:  tensor(0.0259)
55 . Validation loss:  tensor(0.0985)
56 . Training loss:  tensor(0.0247)
56 . Validation loss:  tensor(0.1055)
57 . Training loss:  tensor(0.0237)
57 . Validation loss:  tensor(0.0987)
58 . Training loss:  tensor(0.0238)
58 . Validation loss:  tensor(0.0948)
59 . Training loss:  tensor(0.0215)
59 . Validation loss:  tensor(0.0909)
60 . Training loss:  tensor(0.0206)
60 . Validation loss:  tensor(0.0890)
61 . Training loss:  tensor(0.0198)
61 . Validation loss:  tensor(0.0904)
62 . Training loss:  tensor(0.0191)
62 . Validation loss:  tensor(0.0880)
63 . Training loss:  tensor(0.0183)
63 . Validation loss:  tensor(0.0842)
64 . Training loss:  tensor(0.0175)
64 . Validation loss:  tensor(0.0896)
65 . Training loss:  tensor(0.0170)
65 . Validation loss:  tensor(0.0855)
66 . Training loss:  tensor(0.0163)
66 . Validation loss:  tensor(0.0818)
67 . Training loss:  tensor(0.0158)
67 . Validation loss:  tensor(0.0801)
68 . Training loss:  tensor(0.0153)
68 . Validation loss:  tensor(0.0783)
69 . Training loss:  tensor(0.0148)
69 . Validation loss:  tensor(0.0786)
70 . Training loss:  tensor(0.0143)
70 . Validation loss:  tensor(0.0776)
71 . Training loss:  tensor(0.0140)
71 . Validation loss:  tensor(0.0783)
72 . Training loss:  tensor(0.0135)
72 . Validation loss:  tensor(0.0784)
73 . Training loss:  tensor(0.0131)
73 . Validation loss:  tensor(0.0775)
74 . Training loss:  tensor(0.0128)
74 . Validation loss:  tensor(0.0808)
75 . Training loss:  tensor(0.0124)
75 . Validation loss:  tensor(0.0766)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_10_1.png" src="_images/Battery_SOH_LSTM_10_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  75
2021-07-06 10_32_56.886364
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_10_3.png" src="_images/Battery_SOH_LSTM_10_3.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="_images/Battery_SOH_LSTM_10_4.png" src="_images/Battery_SOH_LSTM_10_4.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0001
B0001
303
B0002
B0002
77
B0003
B0003
64
B0004
B0004
47
B0005
83
B0006
B0006
72
B0008
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
<span class="ansi-red-fg">---------------------------------------------------------------------------</span>
<span class="ansi-red-fg">NotImplementedError</span>                       Traceback (most recent call last)
<span class="ansi-green-fg">&lt;ipython-input-8-924d18059fbf&gt;</span> in <span class="ansi-cyan-fg">&lt;module&gt;</span><span class="ansi-blue-fg">()</span>
<span class="ansi-green-intense-fg ansi-bold">     14</span> simulate<span class="ansi-blue-fg">(</span>valid_loader<span class="ansi-blue-fg">,</span> Model<span class="ansi-blue-fg">,</span> block<span class="ansi-blue-fg">=</span><span class="ansi-green-fg">False</span><span class="ansi-blue-fg">,</span> denormalize<span class="ansi-blue-fg">=</span><span class="ansi-green-fg">True</span><span class="ansi-blue-fg">,</span> device<span class="ansi-blue-fg">=</span>device<span class="ansi-blue-fg">)</span>
<span class="ansi-green-intense-fg ansi-bold">     15</span>
<span class="ansi-green-fg">---&gt; 16</span><span class="ansi-red-fg"> </span>Load_Save<span class="ansi-blue-fg">(</span>date<span class="ansi-blue-fg">,</span> device<span class="ansi-blue-fg">=</span>device<span class="ansi-blue-fg">,</span> plot_bool<span class="ansi-blue-fg">=</span><span class="ansi-green-fg">False</span><span class="ansi-blue-fg">,</span> dataset_name<span class="ansi-blue-fg">=</span>dataset_name<span class="ansi-blue-fg">)</span>

<span class="ansi-green-fg">/content/gdrive/My Drive/battery_soh/Battery_SOH_24_06_15h/Load_Save.py</span> in <span class="ansi-cyan-fg">Load_Save</span><span class="ansi-blue-fg">(report_name, device, plot_bool, analysis, epoch, dataset_name, report_bool)</span>
<span class="ansi-green-intense-fg ansi-bold">    111</span>                                       norm<span class="ansi-blue-fg">=</span>train_tuple<span class="ansi-blue-fg">[</span><span class="ansi-cyan-fg">3</span><span class="ansi-blue-fg">]</span><span class="ansi-blue-fg">,</span>
<span class="ansi-green-intense-fg ansi-bold">    112</span>                                       fixed_len<span class="ansi-blue-fg">=</span>train_tuple<span class="ansi-blue-fg">[</span><span class="ansi-cyan-fg">2</span><span class="ansi-blue-fg">]</span><span class="ansi-blue-fg">,</span>
<span class="ansi-green-fg">--&gt; 113</span><span class="ansi-red-fg">                                       time_step=train_tuple[1], print_bool=True)
</span><span class="ansi-green-intense-fg ansi-bold">    114</span>
<span class="ansi-green-intense-fg ansi-bold">    115</span>         <span class="ansi-green-fg">elif</span> Model<span class="ansi-blue-fg">.</span>model_name <span class="ansi-blue-fg">==</span> <span class="ansi-blue-fg">&#39;RNN&#39;</span><span class="ansi-blue-fg">:</span>

<span class="ansi-green-fg">/content/gdrive/My Drive/battery_soh/Battery_SOH_24_06_15h/LSTM.py</span> in <span class="ansi-cyan-fg">__init__</span><span class="ansi-blue-fg">(self, Battery_list, delta, model_version, print_bool, time_step, threshold, min_len, fixed_len, norm_type, norm)</span>
<span class="ansi-green-intense-fg ansi-bold">    766</span>
<span class="ansi-green-intense-fg ansi-bold">    767</span>         inputs, output, norm = Normalize(ent, sai, norm_type=norm_type,
<span class="ansi-green-fg">--&gt; 768</span><span class="ansi-red-fg">                                          norm=norm)
</span><span class="ansi-green-intense-fg ansi-bold">    769</span>
<span class="ansi-green-intense-fg ansi-bold">    770</span>         <span class="ansi-green-fg">if</span> print_bool<span class="ansi-blue-fg">:</span>

<span class="ansi-green-fg">/content/gdrive/My Drive/battery_soh/Battery_SOH_24_06_15h/Cleaning.py</span> in <span class="ansi-cyan-fg">Normalize</span><span class="ansi-blue-fg">(inputs, output, norm_type, norm, concatenate)</span>
<span class="ansi-green-intense-fg ansi-bold">    847</span>     <span class="ansi-red-fg"># Stacking inputs. This can be done for calculating the normalization information but the actual normalization</span>
<span class="ansi-green-intense-fg ansi-bold">    848</span>     <span class="ansi-red-fg"># may have to be done case by case (concatenate = False).</span>
<span class="ansi-green-fg">--&gt; 849</span><span class="ansi-red-fg">     </span>inputs_stack <span class="ansi-blue-fg">=</span> th<span class="ansi-blue-fg">.</span>cat<span class="ansi-blue-fg">(</span>inputs<span class="ansi-blue-fg">,</span> dim<span class="ansi-blue-fg">=</span><span class="ansi-cyan-fg">0</span><span class="ansi-blue-fg">)</span>
<span class="ansi-green-intense-fg ansi-bold">    850</span>     <span class="ansi-red-fg"># Stacking outputs.</span>
<span class="ansi-green-intense-fg ansi-bold">    851</span>     output_stack <span class="ansi-blue-fg">=</span> th<span class="ansi-blue-fg">.</span>FloatTensor<span class="ansi-blue-fg">(</span>output<span class="ansi-blue-fg">)</span>

<span class="ansi-red-fg">NotImplementedError</span>: There were no tensor arguments to this function (e.g., you passed an empty list of Tensors), but no fallback function is registered for schema aten::_cat.  This usually means that this function requires a non-empty list of Tensors, or that you (the operator writer) forgot to register a fallback function.  Available functions are [CPU, CUDA, QuantizedCPU, BackendSelect, Named, ADInplaceOrView, AutogradOther, AutogradCPU, AutogradCUDA, AutogradXLA, UNKNOWN_TENSOR_TYPE_ID, AutogradMLC, AutogradHPU, AutogradNestedTensor, AutogradPrivateUse1, AutogradPrivateUse2, AutogradPrivateUse3, Tracer, Autocast, Batched, VmapMode].

CPU: registered at /pytorch/build/aten/src/ATen/RegisterCPU.cpp:16286 [kernel]
CUDA: registered at /pytorch/build/aten/src/ATen/RegisterCUDA.cpp:20674 [kernel]
QuantizedCPU: registered at /pytorch/build/aten/src/ATen/RegisterQuantizedCPU.cpp:1025 [kernel]
BackendSelect: fallthrough registered at /pytorch/aten/src/ATen/core/BackendSelectFallbackKernel.cpp:3 [backend fallback]
Named: registered at /pytorch/aten/src/ATen/core/NamedRegistrations.cpp:7 [backend fallback]
ADInplaceOrView: fallthrough registered at /pytorch/aten/src/ATen/core/VariableFallbackKernel.cpp:60 [backend fallback]
AutogradOther: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradCPU: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradCUDA: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradXLA: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
UNKNOWN_TENSOR_TYPE_ID: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradMLC: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradHPU: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradNestedTensor: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradPrivateUse1: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradPrivateUse2: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
AutogradPrivateUse3: registered at /pytorch/torch/csrc/autograd/generated/VariableType_2.cpp:9928 [autograd kernel]
Tracer: registered at /pytorch/torch/csrc/autograd/generated/TraceType_2.cpp:9621 [kernel]
Autocast: registered at /pytorch/aten/src/ATen/autocast_mode.cpp:259 [kernel]
Batched: registered at /pytorch/aten/src/ATen/BatchingRegistrations.cpp:1019 [backend fallback]
VmapMode: fallthrough registered at /pytorch/aten/src/ATen/VmapModeRegistrations.cpp:33 [backend fallback]

</pre></div></div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>